package lt.bit.prekes.servlets;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.hibernate.Session;

import lt.bit.prekes.db.Db;
import lt.bit.prekes.models.Product;

/**
 * Servlet implementation class HomeServlet
 */
@WebServlet("/home")
public class HomeServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public HomeServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//session.get - paimti įrašą, Product.class- nurodo kokio modelio įrašą paimam, 2 - ID laukelio reikšmė
		
		//Vieno įrašo paėmimas (nurodome klasę ir ID)
		//Product p= session.get(Product.class, 2);
		//System.out.println(p);
		
		//Paimami visi įrašai iš DB lentelės products (kuri susieta su klase Product)
		//List<Product> products= session.createQuery("SELECT p FROM Product p", Product.class).getResultList();
		//System.out.println(products);
		
		//Pasiimam duomenis iš DB
		Session session=Db.getSessionFactory().openSession();
		List<Product> products= session.createQuery("SELECT p FROM Product p", Product.class).getResultList();
		session.close();
		
		//"persiunčiame" duomenis į JSP
		request.setAttribute("products", products);
		
		//Užkrauname JSP failą
		RequestDispatcher dispatcher=request.getRequestDispatcher("/products.jsp");
		dispatcher.forward(request, response);
		
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request, response);
	}

}
